
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>FFT tansformed &#8212; Image processing analysis</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet">
  <link href="../_static/css/index.ff1ffe594081f20da1ef19478df9384b.css" rel="stylesheet">

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../_static/sphinx-book-theme.css?digest=c3fdc42140077d1ad13ad2f1588a4309" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../_static/togglebutton.css" />
    <link rel="stylesheet" type="text/css" href="../_static/copybutton.css" />
    <link rel="stylesheet" type="text/css" href="../_static/mystnb.css" />
    <link rel="stylesheet" type="text/css" href="../_static/sphinx-thebe.css" />
    <link rel="stylesheet" type="text/css" href="../_static/panels-main.c949a650a448cc0ae9fd3441c0e17fb0.css" />
    <link rel="stylesheet" type="text/css" href="../_static/panels-variables.06eb56fa6e07937060861dad626602ad.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.be7d3bbb2ef33a8344ce.js">

    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/clipboard.min.js"></script>
    <script src="../_static/copybutton.js"></script>
    <script >let toggleHintShow = 'Click to show';</script>
    <script >let toggleHintHide = 'Click to hide';</script>
    <script >let toggleOpenOnPrint = 'true';</script>
    <script src="../_static/togglebutton.js"></script>
    <script >var togglebuttonSelector = '.toggle, .admonition.dropdown, .tag_hide_input div.cell_input, .tag_hide-input div.cell_input, .tag_hide_output div.cell_output, .tag_hide-output div.cell_output, .tag_hide_cell.cell, .tag_hide-cell.cell';</script>
    <script src="../_static/sphinx-book-theme.d59cb220de22ca1c485ebbdc042f0030.js"></script>
    <script >const THEBE_JS_URL = "https://unpkg.com/thebe@0.8.2/lib/index.js"
const thebe_selector = ".thebe,.cell"
const thebe_selector_input = "pre"
const thebe_selector_output = ".output, .cell_output"
</script>
    <script async="async" src="../_static/sphinx-thebe.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <script src="https://unpkg.com/@jupyter-widgets/html-manager@^0.20.0/dist/embed-amd.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="prev" title="Band detection" href="Band_Detection.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="None">
    

    <!-- Google Analytics -->
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    

    <div class="container-xl">
      <div class="row">
          
<div class="col-12 col-md-3 bd-sidebar site-navigation show" id="site-navigation">
    
        <div class="navbar-brand-box">
    <a class="navbar-brand text-wrap" href="../index.html">
      
        <!-- `logo` is deprecated in Sphinx 4.0, so remove this when we stop supporting 3 -->
        
      
      
      <img src="../_static/logo.png" class="logo" alt="logo">
      
      
      <h1 class="site-logo" id="site-title">Image processing analysis</h1>
      
    </a>
</div><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search this book..." aria-label="Search this book..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main">
    <div class="bd-toc-item active">
        <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="intro.html">
   Welcome to Image Processing Book
  </a>
 </li>
</ul>
<p class="caption">
 <span class="caption-text">
  Tutorials
 </span>
</p>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="Load_images.html">
   Load an image
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="Autocorrelation.html">
   Autocorrelation
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="Texture_Anisotropy.html">
   Texture anisotropy
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="Band_Detection.html">
   Band detection
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   FFT tansformed
  </a>
 </li>
</ul>

    </div>
</nav> <!-- To handle the deprecated key -->

<div class="navbar_extra_footer">
  Powered by <a href="https://jupyterbook.org">Jupyter Book</a>
</div>

</div>


          


          
<main class="col py-md-3 pl-md-4 bd-content overflow-auto" role="main">
    
    <div class="topbar container-xl fixed-top">
    <div class="topbar-contents row">
        <div class="col-12 col-md-3 bd-topbar-whitespace site-navigation show"></div>
        <div class="col pl-md-4 topbar-main">
            
            <button id="navbar-toggler" class="navbar-toggler ml-0" type="button" data-toggle="collapse"
                data-toggle="tooltip" data-placement="bottom" data-target=".site-navigation" aria-controls="navbar-menu"
                aria-expanded="true" aria-label="Toggle navigation" aria-controls="site-navigation"
                title="Toggle navigation" data-toggle="tooltip" data-placement="left">
                <i class="fas fa-bars"></i>
                <i class="fas fa-arrow-left"></i>
                <i class="fas fa-arrow-up"></i>
            </button>
            
            
<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn" aria-label="Download this page"><i
            class="fas fa-download"></i></button>

    <div class="dropdown-buttons">
        <!-- ipynb file if we had a myst markdown file -->
        
        <!-- Download raw file -->
        <a class="dropdown-buttons" href="../_sources/docs/freq_analysis.ipynb"><button type="button"
                class="btn btn-secondary topbarbtn" title="Download source file" data-toggle="tooltip"
                data-placement="left">.ipynb</button></a>
        <!-- Download PDF via print -->
        <button type="button" id="download-print" class="btn btn-secondary topbarbtn" title="Print to PDF"
                onclick="printPdf(this)" data-toggle="tooltip" data-placement="left">.pdf</button>
    </div>
</div>

            <!-- Source interaction buttons -->

<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn"
        aria-label="Connect with source repository"><i class="fab fa-github"></i></button>
    <div class="dropdown-buttons sourcebuttons">
        <a class="repository-button"
            href="https://gricad-gitlab.univ-grenoble-alpes.fr/chauvet/image_processing_book"><button type="button" class="btn btn-secondary topbarbtn"
                data-toggle="tooltip" data-placement="left" title="Source repository"><i
                    class="fab fa-github"></i>repository</button></a>
        <a class="issues-button"
            href="https://gricad-gitlab.univ-grenoble-alpes.fr/chauvet/image_processing_book/issues/new?title=Issue%20on%20page%20%2Fdocs/freq_analysis.html&body=Your%20issue%20content%20here."><button
                type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip" data-placement="left"
                title="Open an issue"><i class="fas fa-lightbulb"></i>open issue</button></a>
        <a class="edit-button" href="https://github.com/chauvet/image_processing_book/edit/main/./docs/freq_analysis.ipynb"><button
                type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip" data-placement="left"
                title="Edit this page"><i class="fas fa-pencil-alt"></i>suggest edit</button></a>
    </div>
</div>

            <!-- Full screen (wrap in <a> to have style consistency -->

<a class="full-screen-button"><button type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip"
        data-placement="bottom" onclick="toggleFullScreen()" aria-label="Fullscreen mode"
        title="Fullscreen mode"><i
            class="fas fa-expand"></i></button></a>

            <!-- Launch buttons -->

        </div>

        <!-- Table of contents -->
        <div class="d-none d-md-block col-md-2 bd-toc show noprint">
            
        </div>
    </div>
</div>
    <div id="main-content" class="row">
        <div class="col-12 col-md-9 pl-md-3 pr-md-0">
            <!-- Table of contents that is only displayed when printing the page -->
            <div id="jb-print-docs-body" class="onlyprint">
                <h1>FFT tansformed</h1>
                <!-- Table of contents -->
                <div id="print-main-content">
                    <div id="jb-print-toc">
                        
                    </div>
                </div>
            </div>
            
              <div>
                
  <div class="tex2jax_ignore mathjax_ignore section" id="fft-tansformed">
<h1>FFT tansformed<a class="headerlink" href="#fft-tansformed" title="Permalink to this headline">¶</a></h1>
<p>This notebook describes a FFT analysis to extract the main periodicity in one image.</p>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">xarray_dic.loadDIC</span> <span class="k">as</span> <span class="nn">xldd</span>
<span class="kn">import</span> <span class="nn">xarray_dic.xarray_dic</span> <span class="k">as</span> <span class="nn">xd</span>
<span class="kn">import</span> <span class="nn">xarray_symTensor2d.xarray_symTensor2d</span> <span class="k">as</span> <span class="nn">xst</span>
<span class="kn">import</span> <span class="nn">xarray</span> <span class="k">as</span> <span class="nn">xr</span>
<span class="kn">import</span> <span class="nn">xarray_image_processing.xarray_image_processing</span>
<span class="kn">import</span> <span class="nn">xarray_image_processing.plot_imP</span> <span class="k">as</span> <span class="nn">xPimp</span>
<span class="kn">import</span> <span class="nn">xarrayaita.aita</span> <span class="k">as</span> <span class="nn">xa</span>
<span class="kn">import</span> <span class="nn">xarrayaita.loadData_aita</span> <span class="k">as</span> <span class="nn">xlda</span>
<span class="kn">import</span> <span class="nn">xarrayuvecs.lut2d</span> <span class="k">as</span> <span class="nn">lut2d</span>

<span class="kn">from</span> <span class="nn">skimage.morphology</span> <span class="kn">import</span> <span class="n">skeletonize</span> <span class="k">as</span> <span class="n">sk</span>
<span class="kn">import</span> <span class="nn">scipy</span> <span class="k">as</span> <span class="nn">sc</span>
<span class="kn">import</span> <span class="nn">scipy.stats</span>
<span class="kn">from</span> <span class="nn">skimage.feature</span> <span class="kn">import</span> <span class="n">peak_local_max</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">matplotlib.cm</span> <span class="k">as</span> <span class="nn">cm</span>
<span class="kn">import</span> <span class="nn">matplotlib.patches</span> <span class="k">as</span> <span class="nn">mp</span>
<span class="kn">import</span> <span class="nn">matplotlib</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">rc</span>
<span class="kn">import</span> <span class="nn">matplotlib.gridspec</span> <span class="k">as</span> <span class="nn">gridspec</span>
<span class="kn">from</span> <span class="nn">tqdm.notebook</span> <span class="kn">import</span> <span class="n">trange</span>
<span class="kn">import</span> <span class="nn">tikzplotlib</span>


<span class="n">rc</span><span class="p">(</span><span class="s1">&#39;font&#39;</span><span class="p">,</span><span class="o">**</span><span class="p">{</span><span class="s1">&#39;family&#39;</span><span class="p">:</span><span class="s1">&#39;serif&#39;</span><span class="p">,</span><span class="s1">&#39;serif&#39;</span><span class="p">:[</span><span class="s1">&#39;Computer Modern Roman&#39;</span><span class="p">],</span><span class="s1">&#39;size&#39;</span><span class="p">:</span><span class="mi">30</span><span class="p">})</span>
<span class="n">rc</span><span class="p">(</span><span class="s1">&#39;text&#39;</span><span class="p">,</span> <span class="n">usetex</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="o">%</span><span class="k">matplotlib</span> inline


<span class="kn">import</span> <span class="nn">warnings</span>
<span class="n">warnings</span><span class="o">.</span><span class="n">filterwarnings</span><span class="p">(</span><span class="s1">&#39;ignore&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">res</span><span class="o">=</span><span class="mf">0.0112</span> <span class="c1"># mm/pix</span>
<span class="n">s_dic</span><span class="o">=</span><span class="mf">0.005</span> <span class="c1"># % deformation</span>
<span class="n">unit_time</span><span class="o">=</span><span class="s1">&#39;macro_strain&#39;</span>
<span class="n">unit_spa</span><span class="o">=</span><span class="s1">&#39;millimeter&#39;</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">hws_window</span><span class="o">=</span><span class="p">[</span><span class="mi">30</span><span class="p">,</span><span class="mi">40</span><span class="p">,</span><span class="mi">50</span><span class="p">,</span><span class="mi">60</span><span class="p">,</span><span class="mi">80</span><span class="p">,</span><span class="mi">100</span><span class="p">,</span><span class="mi">120</span><span class="p">,</span><span class="mi">200</span><span class="p">]</span><span class="c1">#,40,50,60,80,100,120,200]</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">box_size</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">hws_window</span><span class="p">)</span><span class="o">*</span><span class="n">res</span> <span class="c1">#13,15,19,25,33,39,51,101,151</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;GI06&#39;</span>
<span class="n">path</span><span class="o">=</span><span class="s1">&#39;/data/FlorianFiguiere/GI06/spam/nm_analysis/&#39;</span>
<span class="n">dataSp1</span><span class="o">=</span><span class="p">[]</span>
<span class="n">dataSp2</span><span class="o">=</span><span class="p">[]</span>
<span class="n">dataSp3</span><span class="o">=</span><span class="p">[]</span>
<span class="n">macrostrain</span><span class="o">=</span><span class="p">[]</span>
<span class="k">for</span> <span class="n">Speckle</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;SP1_new/&#39;</span><span class="p">,</span><span class="s1">&#39;SP2_new/&#39;</span><span class="p">,</span><span class="s1">&#39;SP3_new/&#39;</span><span class="p">]:</span>
    <span class="k">for</span> <span class="n">tadr</span> <span class="ow">in</span> <span class="n">hws_window</span><span class="p">:</span>
        <span class="n">ds_int</span><span class="o">=</span><span class="n">xldd</span><span class="o">.</span><span class="n">multi_load</span><span class="p">(</span><span class="n">xldd</span><span class="o">.</span><span class="n">loadSpam</span><span class="p">,</span><span class="n">path</span><span class="o">+</span><span class="n">Speckle</span><span class="o">+</span><span class="s1">&#39;disp/n&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">tadr</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;/&#39;</span><span class="p">,</span><span class="n">res</span><span class="p">,</span><span class="n">s_dic</span><span class="p">,</span><span class="n">unit_time</span><span class="o">=</span><span class="n">unit_time</span><span class="p">,</span><span class="n">unit_res</span><span class="o">=</span><span class="n">unit_spa</span><span class="p">)</span> <span class="c1">#More than one correlation</span>
        <span class="n">ds</span><span class="o">=</span><span class="n">ds_int</span><span class="o">.</span><span class="n">dic</span><span class="o">.</span><span class="n">dic_average</span><span class="p">()</span>
        
        <span class="n">ds</span><span class="p">[</span><span class="s1">&#39;eqVM&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds</span><span class="o">.</span><span class="n">strain</span><span class="o">.</span><span class="n">sT</span><span class="o">.</span><span class="n">eqVonMises</span><span class="p">(</span><span class="n">lognorm</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
        <span class="n">ds</span><span class="p">[</span><span class="s1">&#39;eqVM_LN&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds</span><span class="o">.</span><span class="n">strain</span><span class="o">.</span><span class="n">sT</span><span class="o">.</span><span class="n">eqVonMises</span><span class="p">(</span><span class="n">lognorm</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">ds</span><span class="p">[</span><span class="s1">&#39;mean_eyy&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds</span><span class="o">.</span><span class="n">strain</span><span class="o">.</span><span class="n">sT</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="s1">&#39;tyy&#39;</span><span class="p">)</span>
        <span class="n">ds</span><span class="p">[</span><span class="s1">&#39;dl_y&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds</span><span class="o">.</span><span class="n">dic</span><span class="o">.</span><span class="n">DIC_line</span><span class="p">(</span><span class="s1">&#39;y&#39;</span><span class="p">)</span>
        
        <span class="k">if</span> <span class="n">Speckle</span><span class="o">==</span><span class="s1">&#39;SP1_new/&#39;</span><span class="p">:</span>
            <span class="n">dataSp1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ds</span><span class="p">)</span>
            <span class="n">macrostrainSp1</span><span class="o">=</span><span class="n">macrostrain</span>
        <span class="k">elif</span> <span class="n">Speckle</span><span class="o">==</span><span class="s1">&#39;SP2_new/&#39;</span><span class="p">:</span>
            <span class="n">dataSp2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ds</span><span class="p">)</span>
            <span class="n">macrostrainSp2</span><span class="o">=</span><span class="n">macrostrain</span>    
        <span class="k">elif</span> <span class="n">Speckle</span><span class="o">==</span><span class="s1">&#39;SP3_new/&#39;</span><span class="p">:</span>
            <span class="n">dataSp3</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ds</span><span class="p">)</span>
            <span class="n">macrostrainSp3</span><span class="o">=</span><span class="n">macrostrain</span>
</pre></div>
</div>
</div>
</div>
<p>Crop the data</p>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># DIC box size for the analysis</span>
<span class="n">res</span><span class="o">=</span><span class="mi">1</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;DIC Box size :&#39;</span><span class="p">,</span><span class="n">hws_window</span><span class="p">[</span><span class="n">res</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>DIC Box size : 40
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">xmin</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">([</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">.</span><span class="n">min</span><span class="p">(),</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">.</span><span class="n">min</span><span class="p">()])</span>
<span class="n">xmax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">([</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">.</span><span class="n">max</span><span class="p">(),</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">.</span><span class="n">max</span><span class="p">()])</span>
<span class="n">ymin</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">([</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">y</span><span class="o">.</span><span class="n">min</span><span class="p">(),</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">y</span><span class="o">.</span><span class="n">min</span><span class="p">()])</span>
<span class="n">ymax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">([</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">y</span><span class="o">.</span><span class="n">max</span><span class="p">(),</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">y</span><span class="o">.</span><span class="n">max</span><span class="p">()])</span>
</pre></div>
</div>
</div>
</div>
<p>Crop the data</p>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">ds1res</span><span class="o">=</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">dataSp1</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">&gt;</span><span class="n">xmin</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds1res</span><span class="o">=</span><span class="n">ds1res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds1res</span><span class="o">.</span><span class="n">x</span><span class="o">&lt;</span><span class="n">xmax</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds1res</span><span class="o">=</span><span class="n">ds1res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds1res</span><span class="o">.</span><span class="n">y</span><span class="o">&gt;</span><span class="n">ymin</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds1res</span><span class="o">=</span><span class="n">ds1res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds1res</span><span class="o">.</span><span class="n">y</span><span class="o">&lt;</span><span class="n">ymax</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="n">ds21res</span><span class="o">=</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">dataSp2</span><span class="p">[</span><span class="n">res</span><span class="p">]</span><span class="o">.</span><span class="n">x</span><span class="o">&gt;</span><span class="n">xmin</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds21res</span><span class="o">=</span><span class="n">ds21res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds21res</span><span class="o">.</span><span class="n">x</span><span class="o">&lt;</span><span class="n">xmax</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds21res</span><span class="o">=</span><span class="n">ds21res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds21res</span><span class="o">.</span><span class="n">y</span><span class="o">&gt;</span><span class="n">ymin</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">ds21res</span><span class="o">=</span><span class="n">ds21res</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds21res</span><span class="o">.</span><span class="n">y</span><span class="o">&lt;</span><span class="n">ymax</span><span class="p">,</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="k">def</span> <span class="nf">extract_freq</span><span class="p">(</span><span class="n">image1</span><span class="p">):</span>
    <span class="n">fft_res</span><span class="o">=</span><span class="n">scipy</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fft2</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">fliplr</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">image1</span><span class="p">)))</span>
    <span class="n">fft_res_tmp</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">fft_res</span><span class="p">)</span>
    <span class="c1"># filter low frequency</span>
    <span class="n">i</span><span class="o">=</span><span class="mi">3</span>
    <span class="n">fft_res_tmp</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span><span class="p">,</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span><span class="p">]</span><span class="o">=</span><span class="mi">0</span>
    <span class="n">fft_res_tmp</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span><span class="p">,</span><span class="o">-</span><span class="n">i</span><span class="p">:]</span><span class="o">=</span><span class="mi">0</span>
    <span class="n">fft_res_tmp</span><span class="p">[</span><span class="o">-</span><span class="n">i</span><span class="p">:,</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span><span class="p">]</span><span class="o">=</span><span class="mi">0</span>
    <span class="n">fft_res_tmp</span><span class="p">[</span><span class="o">-</span><span class="n">i</span><span class="p">:,</span><span class="o">-</span><span class="n">i</span><span class="p">:]</span><span class="o">=</span><span class="mi">0</span>
    
    <span class="n">coordinates</span><span class="o">=</span><span class="n">peak_local_max</span><span class="p">(</span><span class="n">fft_res_tmp</span><span class="p">,</span><span class="n">threshold_abs</span><span class="o">=</span><span class="mf">0.95</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">fft_res_tmp</span><span class="p">))</span>
    
    <span class="c1">#idm=np.where(np.abs(fft_res_tmp)==np.max(np.abs(fft_res_tmp)))</span>
    
    <span class="n">freq0</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fftfreq</span><span class="p">(</span><span class="n">image1</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">freq1</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fftfreq</span><span class="p">(</span><span class="n">image1</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>

    <span class="n">fake_fft</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">fft_res</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
    <span class="n">fake_fft</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[:,</span><span class="mi">0</span><span class="p">],</span><span class="n">coordinates</span><span class="p">[:,</span><span class="mi">1</span><span class="p">]]</span><span class="o">=</span><span class="n">fft_res</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[:,</span><span class="mi">0</span><span class="p">],</span><span class="n">coordinates</span><span class="p">[:,</span><span class="mi">1</span><span class="p">]]</span>
    
    <span class="n">ang</span><span class="o">=</span><span class="p">[]</span>
    <span class="n">wl</span><span class="o">=</span><span class="p">[]</span>
    
    <span class="n">rr</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="n">coordinates</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
    <span class="n">rr</span><span class="o">=</span><span class="n">rr</span><span class="p">[</span><span class="n">rr</span><span class="o">%</span><span class="k">2</span>==0] # keep only even by symmetry
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">rr</span><span class="p">:</span>
        <span class="n">ang</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="o">/</span><span class="mi">2</span><span class="o">+</span><span class="n">np</span><span class="o">.</span><span class="n">arctan</span><span class="p">(</span><span class="n">freq1</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[</span><span class="n">i</span><span class="p">,</span><span class="mi">1</span><span class="p">]]</span><span class="o">/</span><span class="n">freq0</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[</span><span class="n">i</span><span class="p">,</span><span class="mi">0</span><span class="p">]]))</span>
        <span class="n">wl</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">image1</span><span class="o">.</span><span class="n">xa</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span><span class="o">/</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">freq1</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[</span><span class="n">i</span><span class="p">,</span><span class="mi">1</span><span class="p">]]</span><span class="o">**</span><span class="mi">2</span><span class="o">+</span><span class="n">freq0</span><span class="p">[</span><span class="n">coordinates</span><span class="p">[</span><span class="n">i</span><span class="p">,</span><span class="mi">0</span><span class="p">]]</span><span class="o">**</span><span class="mi">2</span><span class="p">))</span>
    
    <span class="n">ang</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">ang</span><span class="p">)</span>
    <span class="n">wl</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">wl</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">ang</span><span class="p">,</span> <span class="n">wl</span><span class="p">,</span><span class="n">np</span><span class="o">.</span><span class="n">real</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">ifft2</span><span class="p">(</span><span class="n">fake_fft</span><span class="p">)),</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fftshift</span><span class="p">(</span><span class="n">fft_res</span><span class="p">)),</span><span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fftshift</span><span class="p">(</span><span class="n">freq0</span><span class="p">),</span><span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fftshift</span><span class="p">(</span><span class="n">freq1</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="k">def</span> <span class="nf">plot_eqVM_polar</span><span class="p">(</span><span class="n">im1</span><span class="p">,</span><span class="n">vmm</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span><span class="n">clim</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
    
    <span class="k">if</span> <span class="n">vmm</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span>
        <span class="n">vmm</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">([</span><span class="n">im1</span><span class="o">.</span><span class="n">max</span><span class="p">()])</span>

    <span class="n">lx1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">im1</span><span class="o">.</span><span class="n">x</span><span class="p">)</span>
    <span class="n">ly1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">im1</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
    <span class="n">ly1p</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">im1</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
    
    <span class="n">sc1</span><span class="o">=</span><span class="n">mp</span><span class="o">.</span><span class="n">Rectangle</span><span class="p">([</span><span class="n">lx1</span><span class="o">+</span><span class="mi">3</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span><span class="mi">10</span><span class="p">,</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">ar1y</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">7.5</span> <span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">ar1x</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">7.5</span> <span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>

    <span class="n">lx1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">im1</span><span class="o">.</span><span class="n">x</span><span class="p">)</span>
    <span class="n">ly1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">im1</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
    
    <span class="n">im1b</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">im1</span><span class="o">/</span><span class="n">np</span><span class="o">.</span><span class="n">nanmedian</span><span class="p">(</span><span class="n">im1</span><span class="p">,</span><span class="n">axis</span><span class="o">=</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mi">2</span><span class="p">)))</span>
    <span class="k">if</span> <span class="n">clim</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span>
        <span class="n">clim</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nanmax</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">im1b</span><span class="p">)))</span>
    
    <span class="n">fig</span><span class="o">=</span><span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">18</span><span class="p">,</span><span class="mi">18</span><span class="p">),</span><span class="n">constrained_layout</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">rc</span><span class="p">(</span><span class="s1">&#39;font&#39;</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
    <span class="n">gs</span> <span class="o">=</span> <span class="n">matplotlib</span><span class="o">.</span><span class="n">gridspec</span><span class="o">.</span><span class="n">GridSpec</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="n">figure</span><span class="o">=</span><span class="n">fig</span><span class="p">,</span><span class="n">width_ratios</span><span class="o">=</span> <span class="p">[</span><span class="mi">4</span><span class="p">,</span><span class="mi">4</span><span class="p">,</span><span class="mi">4</span><span class="p">])</span>
    
    <span class="n">ax2</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">])</span>
    
    <span class="n">ax2</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.2</span><span class="p">,</span> <span class="s1">&#39;(c)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax2</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    
    <span class="n">ax3</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">2</span><span class="p">::,</span> <span class="mi">2</span><span class="p">],</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;polar&#39;</span><span class="p">)</span>
    <span class="n">ax3</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.6</span><span class="p">,</span> <span class="s1">&#39;(f)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax3</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    
<span class="c1">#     fig.tight_layout(h_pad=3)</span>
    <span class="c1">###########################</span>
    <span class="c1">#### Strain field plot ####</span>
    <span class="c1">###########################</span>
    <span class="n">ax1</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">2</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="s1">&#39;(a)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax1</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    <span class="n">p</span><span class="o">=</span><span class="n">im1</span><span class="o">.</span><span class="n">plot</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="n">add_colorbar</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="c1">#cb = plt.colorbar(p, shrink=0.4, label=&#39;$log(\\frac{\\varepsilon_{eqVM}}{median(\\varepsilon_{eqVM})})$&#39;, orientation=&#39;horizontal&#39;)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">sc1</span><span class="p">)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar1x</span><span class="p">)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar1y</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">7.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">7.5</span><span class="p">,</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">3.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">4.5</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">6.0</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span><span class="s1">&#39;1 cm&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">22</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;Strain field : $\mathcal</span><span class="si">{I}</span><span class="s1">=</span><span class="se">\\</span><span class="s1">varepsilon_</span><span class="si">{eqVM}</span><span class="s1">$&#39;</span><span class="p">)</span>
    
    <span class="c1">###########################</span>
    <span class="c1">####      PDF plot     ####</span>
    <span class="c1">###########################</span>
    <span class="n">kd1</span><span class="o">=</span><span class="n">scipy</span><span class="o">.</span><span class="n">stats</span><span class="o">.</span><span class="n">gaussian_kde</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">im1</span><span class="p">)</span><span class="o">.</span><span class="n">flatten</span><span class="p">())</span>

    <span class="n">xk</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">vmm</span><span class="p">,</span><span class="mi">100</span><span class="p">)</span>
    <span class="n">yk1</span><span class="o">=</span><span class="n">kd1</span><span class="o">.</span><span class="n">evaluate</span><span class="p">(</span><span class="n">xk</span><span class="p">)</span>
    <span class="n">ykm</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">yk1</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">fill_between</span><span class="p">(</span><span class="n">xk</span><span class="p">,</span><span class="n">yk1</span><span class="p">,</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;skyblue&#39;</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">axvline</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nanmedian</span><span class="p">(</span><span class="n">im1</span><span class="p">,</span><span class="n">axis</span><span class="o">=</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mi">2</span><span class="p">)),</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;k&#39;</span><span class="p">,</span> <span class="n">linestyle</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="n">ykm</span><span class="p">])</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="n">vmm</span><span class="p">])</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">spines</span><span class="p">[</span><span class="s1">&#39;right&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">set_visible</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">spines</span><span class="p">[</span><span class="s1">&#39;top&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">set_visible</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s1">&#39;PDF $</span><span class="se">\\</span><span class="s1">varepsilon_</span><span class="si">{eqVM}</span><span class="s1">$&#39;</span><span class="p">)</span>
    

    <span class="n">theta</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">359</span><span class="p">,</span><span class="mi">360</span><span class="p">)</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="o">/</span><span class="mi">180</span>
    <span class="n">ds_a1</span><span class="o">=</span><span class="n">im1</span><span class="o">.</span><span class="n">imP</span><span class="o">.</span><span class="n">auto_correlation</span><span class="p">(</span><span class="n">pad</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span><span class="n">fill_inf</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">ll</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">lmax</span><span class="p">,</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">lmax</span><span class="p">])</span>  
    
    <span class="n">image1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">/</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">Cinf</span><span class="p">)</span>
    
    <span class="n">res</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">image1</span><span class="o">.</span><span class="n">xa</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    <span class="n">ss</span><span class="o">=</span><span class="n">image1</span><span class="o">.</span><span class="n">shape</span>
    <span class="n">xxl</span><span class="o">=</span><span class="n">ll</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">cos</span><span class="p">(</span><span class="n">theta</span><span class="p">)</span><span class="o">+</span><span class="n">res</span><span class="o">*</span><span class="p">(</span><span class="n">ss</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span>
    <span class="n">yyl</span><span class="o">=</span><span class="n">ll</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">sin</span><span class="p">(</span><span class="n">theta</span><span class="p">)</span><span class="o">+</span><span class="n">res</span><span class="o">*</span><span class="p">(</span><span class="n">ss</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span>
    
    <span class="n">ang</span><span class="p">,</span><span class="n">wl</span><span class="p">,</span><span class="n">img</span><span class="p">,</span><span class="n">fft_res</span><span class="p">,</span><span class="n">freq0</span><span class="p">,</span><span class="n">freq1</span><span class="o">=</span><span class="n">extract_freq</span><span class="p">(</span><span class="n">image1</span><span class="p">)</span>
        
    
    
    <span class="c1">###########################</span>
    <span class="c1">####   autocor plot    ####</span>
    <span class="c1">###########################</span>
    
    <span class="n">ax1b</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">2</span><span class="p">,</span> <span class="mi">1</span><span class="p">])</span>
    <span class="n">ax1b</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="s1">&#39;(b)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax1b</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    <span class="n">lx1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">.</span><span class="n">xa</span><span class="p">)</span>
    <span class="n">ly1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">.</span><span class="n">ya</span><span class="p">)</span>
    <span class="n">ly1p</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">.</span><span class="n">ya</span><span class="p">)</span>
    
    <span class="n">sc2</span><span class="o">=</span><span class="n">mp</span><span class="o">.</span><span class="n">Rectangle</span><span class="p">([</span><span class="n">lx1</span><span class="o">+</span><span class="mi">3</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span><span class="mi">20</span><span class="p">,</span><span class="mi">6</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">ar2y</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">12.5</span> <span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">ar2x</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">12.5</span> <span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    
    <span class="n">image1</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">vmin</span><span class="o">=-</span><span class="mf">0.02</span><span class="p">,</span><span class="n">vmax</span><span class="o">=</span><span class="mf">0.02</span><span class="p">,</span><span class="n">cmap</span><span class="o">=</span><span class="n">cm</span><span class="o">.</span><span class="n">bwr</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">xxl</span><span class="p">,</span><span class="n">yyl</span><span class="p">,</span><span class="s1">&#39;--k&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
    <span class="n">ax1b</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">sc2</span><span class="p">)</span>
    <span class="n">ax1b</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar2x</span><span class="p">)</span>
    <span class="n">ax1b</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar2y</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">7.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">11.5</span><span class="p">,</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">3.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">4.5</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">8.4</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mf">3.3</span><span class="p">,</span><span class="s1">&#39;2 cm&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">22</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;$A(\mathcal</span><span class="si">{I}</span><span class="s1">)$&#39;</span><span class="p">)</span>
    
    <span class="c1">###########################</span>
    <span class="c1">####     freq plot     ####</span>
    <span class="c1">###########################</span>
    <span class="n">ax1c</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">2</span><span class="p">::,</span> <span class="mi">0</span><span class="p">])</span>
    <span class="n">ax1c</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="s1">&#39;(d)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax1c</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="n">fft_res</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">ss</span><span class="o">=</span><span class="n">fft_res</span><span class="o">.</span><span class="n">shape</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticks</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="n">ss</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">/</span><span class="mi">2</span><span class="p">,</span><span class="n">ss</span><span class="p">[</span><span class="mi">1</span><span class="p">]]))</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">([</span><span class="n">freq1</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span><span class="s1">&#39;0&#39;</span><span class="p">,</span><span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">freq1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">)])</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_yticks</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="n">ss</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">/</span><span class="mi">2</span><span class="p">,</span><span class="n">ss</span><span class="p">[</span><span class="mi">0</span><span class="p">]]))</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_yticklabels</span><span class="p">([</span><span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">freq0</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">),</span><span class="s1">&#39;0&#39;</span><span class="p">,</span><span class="n">freq0</span><span class="p">[</span><span class="mi">0</span><span class="p">]])</span>
    <span class="c1">#plt.axis(&#39;off&#39;)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;$f_x$&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;$f_y$&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;fft$(A(\mathcal</span><span class="si">{I}</span><span class="s1">))$&#39;</span><span class="p">)</span>
    
    <span class="c1">###########################</span>
    <span class="c1">####  fake auto plot   ####</span>
    <span class="c1">###########################</span>
    <span class="n">sc3</span><span class="o">=</span><span class="n">mp</span><span class="o">.</span><span class="n">Rectangle</span><span class="p">([</span><span class="n">lx1</span><span class="o">+</span><span class="mi">3</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span><span class="mi">20</span><span class="p">,</span><span class="mi">6</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">ar3y</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">12.5</span> <span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">ar3x</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Arrow</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">ly1p</span><span class="o">-</span><span class="mf">12.5</span> <span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span><span class="n">facecolor</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    
    <span class="n">ax1d</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">2</span><span class="p">::,</span> <span class="mi">1</span><span class="p">])</span>
    <span class="n">ax1d</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">,</span> <span class="s1">&#39;(e)&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax1d</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">30</span><span class="p">,</span> <span class="n">weight</span><span class="o">=</span><span class="s1">&#39;bold&#39;</span><span class="p">)</span>
    <span class="n">fake_AC_im</span><span class="o">=</span><span class="n">xr</span><span class="o">.</span><span class="n">DataArray</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">fliplr</span><span class="p">(</span><span class="n">img</span><span class="p">),</span><span class="n">dims</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;ya&#39;</span><span class="p">,</span><span class="s1">&#39;xa&#39;</span><span class="p">])</span>
    <span class="n">fake_AC_im</span><span class="p">[</span><span class="s1">&#39;xa&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">.</span><span class="n">xa</span>
    <span class="n">fake_AC_im</span><span class="p">[</span><span class="s1">&#39;ya&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">ds_a1</span><span class="o">.</span><span class="n">AutoCorrelation</span><span class="o">.</span><span class="n">ya</span>
    <span class="n">fake_AC_im</span><span class="o">.</span><span class="n">plot</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
    <span class="n">ax1d</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">sc3</span><span class="p">)</span>
    <span class="n">ax1d</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar3x</span><span class="p">)</span>
    <span class="n">ax1d</span><span class="o">.</span><span class="n">add_patch</span><span class="p">(</span><span class="n">ar3y</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">7.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">11.5</span><span class="p">,</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">3.5</span><span class="p">,</span><span class="n">ly1p</span><span class="o">-</span><span class="mf">4.5</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">32</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;black&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="n">lx1</span><span class="o">+</span><span class="mf">8.4</span><span class="p">,</span><span class="n">ly1</span><span class="o">+</span><span class="mf">3.3</span><span class="p">,</span><span class="s1">&#39;2 cm&#39;</span><span class="p">,</span><span class="n">fontsize</span><span class="o">=</span><span class="mi">22</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;ifft(max(fft$(A(\mathcal</span><span class="si">{I}</span><span class="s1">))$))&#39;</span><span class="p">)</span>
    
    <span class="c1">###########################sp</span>
    <span class="c1">####  polar auto plot  ####</span>
    <span class="c1">###########################</span>
    <span class="c1">#_, ax = plt.subplots(subplot_kw={&#39;projection&#39;: &#39;polar&#39;})</span>
    
    <span class="c1">#ax3=plt.subplot(325, projection=&#39;polar&#39;)</span>
    <span class="n">ax3</span><span class="o">.</span><span class="n">fill</span><span class="p">(</span><span class="n">theta</span><span class="p">,</span> <span class="n">ll</span><span class="p">,</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;tan&#39;</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">ang</span><span class="p">)):</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">arrow</span><span class="p">(</span><span class="n">ang</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">wl</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">alpha</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">,</span> <span class="n">width</span> <span class="o">=</span> <span class="mf">0.10</span><span class="p">,</span><span class="n">edgecolor</span> <span class="o">=</span> <span class="s1">&#39;black&#39;</span><span class="p">,</span> <span class="n">facecolor</span> <span class="o">=</span> <span class="s1">&#39;cyan&#39;</span><span class="p">,</span> <span class="n">lw</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">zorder</span> <span class="o">=</span> <span class="mi">5</span><span class="p">,</span><span class="n">head_length</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">arrow</span><span class="p">(</span><span class="n">ang</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">wl</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">alpha</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">,</span> <span class="n">width</span> <span class="o">=</span> <span class="mf">0.10</span><span class="p">,</span><span class="n">edgecolor</span> <span class="o">=</span> <span class="s1">&#39;black&#39;</span><span class="p">,</span> <span class="n">facecolor</span> <span class="o">=</span> <span class="s1">&#39;cyan&#39;</span><span class="p">,</span> <span class="n">lw</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">zorder</span> <span class="o">=</span> <span class="mi">5</span><span class="p">,</span><span class="n">head_length</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">ax3</span><span class="o">.</span><span class="n">set_rmax</span><span class="p">(</span><span class="mi">40</span><span class="p">)</span>
    
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticks</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="mi">45</span><span class="p">,</span><span class="mi">90</span><span class="p">,</span><span class="mi">135</span><span class="p">,</span><span class="mi">180</span><span class="p">,</span><span class="mi">225</span><span class="p">,</span><span class="mi">270</span><span class="p">,</span><span class="mi">315</span><span class="p">])</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="o">/</span><span class="mf">180.</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">([</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="s1">&#39;+45&#39;</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="s1">&#39;-45&#39;</span><span class="p">,</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="s1">&#39;+45&#39;</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="s1">&#39;-45&#39;</span><span class="p">])</span>
    <span class="c1">#ax.set_rticks([0.5, 1, 1.5, 2])  # Less radial ticks</span>
    <span class="c1">#ax.set_rlabel_position(-22.5)  # Move radial labels away from plotted line</span>
    <span class="c1">#ax.grid(True)</span>
    <span class="n">ax3</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s2">&quot;Auto-correlation radius (mm)&quot;</span><span class="p">,</span> <span class="n">labelpad</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticks</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="mi">45</span><span class="p">,</span><span class="mi">90</span><span class="p">,</span><span class="mi">135</span><span class="p">,</span><span class="mi">180</span><span class="p">,</span><span class="mi">225</span><span class="p">,</span><span class="mi">270</span><span class="p">,</span><span class="mi">315</span><span class="p">])</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="o">/</span><span class="mf">180.</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">([</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="s1">&#39;+45&#39;</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="s1">&#39;-45&#39;</span><span class="p">,</span><span class="s1">&#39;x&#39;</span><span class="p">,</span><span class="s1">&#39;+45&#39;</span><span class="p">,</span><span class="s1">&#39;y&#39;</span><span class="p">,</span><span class="s1">&#39;-45&#39;</span><span class="p">])</span>
    <span class="k">return</span> <span class="n">fig</span>
</pre></div>
</div>
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">fig1</span><span class="o">=</span><span class="n">plot_eqVM_polar</span><span class="p">(</span><span class="n">ds21res</span><span class="o">.</span><span class="n">eqVM</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="o">...</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../_images/freq_analysis_13_0.png" src="../_images/freq_analysis_13_0.png" />
</div>
</div>
<div class="cell tag_hide-input docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">fig2</span><span class="o">=</span><span class="n">plot_eqVM_polar</span><span class="p">(</span><span class="n">ds21res</span><span class="o">.</span><span class="n">eqVM</span><span class="p">[</span><span class="mi">1</span><span class="p">,</span><span class="o">...</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../_images/freq_analysis_14_0.png" src="../_images/freq_analysis_14_0.png" />
</div>
</div>
</div>

    <script type="text/x-thebe-config">
    {
        requestKernel: true,
        binderOptions: {
            repo: "binder-examples/jupyter-stacks-datascience",
            ref: "master",
        },
        codeMirrorConfig: {
            theme: "abcdef",
            mode: "basepy39"
        },
        kernelOptions: {
            kernelName: "basepy39",
            path: "./docs"
        },
        predefinedOutput: true
    }
    </script>
    <script>kernelName = 'basepy39'</script>

              </div>
              
            
                <!-- Previous / next buttons -->
<div class='prev-next-area'> 
    <a class='left-prev' id="prev-link" href="Band_Detection.html" title="previous page">
        <i class="fas fa-angle-left"></i>
        <div class="prev-next-info">
            <p class="prev-next-subtitle">previous</p>
            <p class="prev-next-title">Band detection</p>
        </div>
    </a>
</div>
            
        </div>
    </div>
    <footer class="footer">
  <p>
    
      By Thomas Chauve<br/>
    
        &copy; Copyright 2021.<br/>
  </p>
</footer>
</main>


      </div>
    </div>
  
  <script src="../_static/js/index.be7d3bbb2ef33a8344ce.js"></script>

  </body>
</html>